#!/bin/bash

source site-options.conf

#
# run nc command
#
echo "ruok" | nc localhost 2181  ; echo ''

#
# create zookeeper response file
#
mkdir /opt/zookeeper-3.4.9/tmp
echo "addauth digest $ZOOKEEPER_USER:$ZOOKEEPER_PASSWORD" > /opt/zookeeper-3.4.9/tmp/input.txt
echo "quit" >> /opt/zookeeper-3.4.9/tmp/input.txt

#
# set zookeeper userid and password
#
/opt/zookeeper-3.4.9/bin/zkCli.sh -server 127.0.0.1:2181 < /opt/zookeeper-3.4.9/tmp/input.txt

#
# add coordination line to st2.conf
#
echo " " >> /etc/st2/st2.conf
echo "[coordination]" >> /etc/st2/st2.conf
echo "url = kazoo://$ZOOKEEPER_USER:$ZOOKEEPER_PASSWORD@localhost:2181" >> /etc/st2/st2.conf

#
# install kazoo and restart StackStorm
#
source /opt/stackstorm/st2/bin/activate
pip install kazoo
st2ctl restart

#
# delete site-options.conf
#
rm -f /opt/stackstorm/installer/site-options.conf
