'''
Created on May 9, 2016

@author: Sreedhar
'''
from st2actions.runners.pythonrunner import Action
import os
import sys
from st2common.constants import action as action_constants
import retrying
import requests
import json
import base64
from st2client import client as st2
from st2client import models



__all__ = [
    'MessageHandler'
]

class MessageHandler(Action):

    def run(self, message):
        in_message=message['body']
        print message
        params={}
        action_name=in_message['workflowId']
        for arg in in_message['workflowArguments']:
            if len(arg['value']) > 0:
                params[arg['name']] = arg['value']
        
        params['actionhub_payload']=json.loads(in_message['originalMessage'])
        username = self.config.get('st2_username')
        password = self.config.get('st2_password')
        headers = {"Authorization": "BASIC " +  base64.b64encode(username + ":" + password)}
        response = requests.post('https://127.0.0.1/auth/v1/tokens', headers=headers,
                                 verify=False)
        res = response.json()
            
        st2client = st2.Client(base_url='http://127.0.0.1',token=res['token'])
        execution = models.LiveAction(action=action_name, parameters=(params))
        execution = st2client.liveactions.create(execution)
        execution=self._wait_for_completion(st2client, execution)
        result=None
        if execution.status == action_constants.LIVEACTION_STATUS_SUCCEEDED:
            if len(execution.result['tasks']) > 0:
                t=execution.result['tasks'][len(execution.result['tasks'])-1]
                if 'result' in t:
                    result_obj = t.get('result')
                    if result_obj:
                        result=result_obj[0]

            
        return [action_name, result]

    @retrying.retry(wait_fixed=3000, stop_max_delay=900000)
    def _wait_for_completion(self,st2client, execution, expect_tasks_completed=True):
        execution = st2client.liveactions.get_by_id(execution.id)
        if expect_tasks_completed:
            if execution.status not in action_constants.LIVEACTION_COMPLETED_STATES:
                raise IOError("Not Completed")

        return execution


if __name__ == "__main__":
    xd=MessageHandler()

