'''
Created on Aug 8, 2016

@author: Sreedhar
'''
from st2actions.runners.pythonrunner import Action
import os
import sys
from st2common.constants import action as action_constants
import retrying
import requests
import json
import base64
from appdynamics_base import AppDynamicsBase


__all__ = [
    'AlertRespondMetrics'
]

class AlertRespondMetrics(AppDynamicsBase):

    def run(self, application_id,time_range_type,duration_in_mins,start_time,end_time,event_types,severities,output='XML'):
        if time_range_type not in ['BEFORE_NOW','BEFORE_TIME','AFTER_TIME','BETWEEN_TIMES']:
            raise ValueError('time_range_type is not valid type')
        if time_range_type  in ['BEFORE_TIME','AFTER_TIME','BETWEEN_TIMES'] and start_time==None:
            raise ValueError('start_time is required')
        if time_range_type  in ['BETWEEN_TIMES'] and end_time==None:
            raise ValueError('end_time is required')
        if output!=None and output not in ['XML','JSON']:
            raise ValueError('Not a valid output type')

        payload = {
            'time-range-type':time_range_type,
            'duration-in-mins':duration_in_mins,
            'start-time':start_time,
            'end-time':end_time,
            'event-types':event_types,
            'severities':severities,
            'output':output
        }
        params=""
        for key in payload.keys():
            if payload[key] != None:
                params=(params+key+'='+str(payload[key])+'&')
            
        res = requests.get(self.config['url']+'/controller/rest/applications/{0}/events?{1}'.format(application_id,params),
                           headers=self.authenticateHeader(),
                           verify=False)
        return res._content
            
if __name__ == "__main__":
    xd=AlertRespondMetrics().run()
