'''
Created on Aug 8, 2016

@author: Sreedhar
'''
from st2actions.runners.pythonrunner import Action
import os
import sys
from st2common.constants import action as action_constants
import retrying
import requests
import json
import base64
from appdynamics_base import AppDynamicsBase



__all__ = [
    'MetricsSnapshot'
]

class MetricsSnapshot(AppDynamicsBase):

    def run(self, application_name,metric_path,time_range_type,duration_in_mins,start_time,end_time,output='XML'):
        if time_range_type not in ['BEFORE_NOW','BEFORE_TIME','AFTER_TIME','BETWEEN_TIMES']:
            raise ValueError('time_range_type is not valid type')
        if time_range_type in ['BEFORE_TIME','AFTER_TIME','BETWEEN_TIMES'] and start_time==None:
            raise ValueError('start_time is required')
        if time_range_type  in ['BETWEEN_TIMES'] and end_time==None:
            raise ValueError('end_time is required')
        if output!=None and output not in ['XML','JSON']:
            raise ValueError('Not a valid output type')

        payload = {
            'metric-path': metric_path,
            'time-range-type':time_range_type,
            'duration-in-mins':duration_in_mins,
            'start-time':start_time,
            'end-time':end_time,
            'output':output
        }
        params=""
        for key in payload.keys():
            if payload[key] != None:
                params=(params+key+'='+str(payload[key])+'&')
        req_url=self.config['url']+'/controller/rest/applications/{0}/metric-data?{1}'.format(application_name,params)    
        res = requests.get(req_url,
                           headers=self.authenticateHeader(),
                           verify=False)
        return res._content
            
if __name__ == "__main__":
    xd=MetricsSnapshot('appdynamics-cloudautomationsolutions.saas.appdynamics.com-user1',14992,'Overall Application Performance|Average Response Time (ms)','BEFORE_NOW',15,).run()
