'''
Created on Sep 1, 2016

@author: Sreedhar
'''


from st2reactor.sensor.base import PollingSensor
from st2client.client import Client
from st2client.models.keyvalue import KeyValuePair
import sys
import requests
import base64
import datetime

class HealthEventsSensor(PollingSensor):
    def __init__(self, sensor_service, config=None, poll_interval=5):
        super(HealthEventsSensor, self).__init__(sensor_service=sensor_service, config=config, poll_interval=poll_interval)
        self._client = Client(base_url='http://localhost')

    def setup(self):
        pass

    def poll(self):
        headers={"authorization": "Basic " +  base64.b64encode(self.config['username']+"@"+self.config['account'] + ":"+self.config['password'])}
        projects=self._config['projects'].split(',')
        for project in projects:
            eventid_key=project+'-event-id'
            params='time-range-type=BEFORE_NOW&duration-in-mins=15&severities=INFO,WARN,ERROR&output=JSON&event-types='+self.config['eventtypes']
            response = requests.get(self.config['url']+'/controller/rest/applications/{0}/events?{1}'.format(project,params),
                               headers=headers,
                               verify=False)
            events= response.json()
            new_events=[]
            lastEventIdKey=self._client.keys.get_by_name(eventid_key)
            lastEventId=0
            if  lastEventIdKey!= None:
                lastEventId=int(lastEventIdKey.value)
                for event in events:
                    if event['id'] > lastEventId:
                        new_events.append(event)
            else:
                new_events=events
            if len(new_events) > 0:
                for event in new_events:
                    if event['id'] > lastEventId:
                        lastEventId=event['id']
                    payload = {"body":event}
                    self._sensor_service.dispatch(trigger="appdynamics.new_event",payload=payload)
                    print 'dispatched to trigger appdynamics.new_event'

            if lastEventIdKey == None:
                lastEventIdKey=KeyValuePair()
            lastEventIdKey.id = eventid_key
            lastEventIdKey.name = eventid_key
            lastEventIdKey.value = str(lastEventId)
            self._client.keys.update(lastEventIdKey)


    def cleanup(self):
        pass

    def add_trigger(self, trigger):
        pass

    def update_trigger(self, trigger):
        pass

    def remove_trigger(self, trigger):
        pass

if __name__ == "__main__":
    obj=HealthEventsSensor()
    obj.poll()
    obj.poll()
    obj.poll()
