import os
import textwrap
from subprocess import check_output
from tempfile import NamedTemporaryFile

from st2actions.runners.pythonrunner import Action


class RunScriptAction(Action):
    def run(self, hostname, username, password, script):
        password = password or self.config['password']
        preamble = '''
                   silent on
                   server add default {hostname}
                   return
                   server default set trustCert 1
                   connect default as {username} with password {password}
                   '''.format(hostname=hostname, username=username, password=password)
        result = ''
        # Check for existence
        if not os.path.exists('/usr/bin/ctf'):
            raise Exception('The teamforge client could not be found in /usr/bin/ctf.')
        with NamedTemporaryFile(mode='a') as script_file:
            # Write preamble to temp file
            script_file.write(textwrap.dedent(preamble))
            # Append script to file
            script_file.write(script)
            # Flush the file stream to ensure data is actually written to file
            script_file.flush()
            result = check_output('/usr/bin/ctf --mode quiet {}'.format(script_file.name), shell=True)
        return result
