'''
Created on Feb 18, 2016

@author: Sreedhar
'''

from st2actions.runners.pythonrunner import Action

import urllib2
import urllib
import json

__all__ = [
    'ServerDiskUtilization'
]

SERVER_LIST_URL='https://api.newrelic.com/v2/servers.json'
SERVER_METRIC_URL='https://api.newrelic.com/v2/servers/{0}/metrics/data.json'
USER_NAME='<user>'
PASSWORD='<passwd>'
DISK_METRIC_NAME='System/Swap/Used/bytes'

class ServerDiskUtilization(Action):

    def basic_authorization(self,user, password):
        s = user + ":" + password
        return "Basic " + s.encode("base64").rstrip()

    def getServerList(self):
        headers = {
            'X-Api-Key': self.config.get('api_key', None),
            'Content-Type': 'application/json'
            }

        req = urllib2.Request(SERVER_LIST_URL,headers=headers)
        response = urllib2.urlopen(req).read()
        servers=json.loads(response)['servers']
        return servers

    def getServerDiskMetricData(self,server_id,metric_base_name,time_from,time_to,actual_metrics):
        headers = {
            'X-Api-Key': self.config.get('api_key', None),
            'Content-Type': 'application/json'
            }
        params = {
            'names[]': metric_base_name,
            'from':time_from,
            'to':time_to,
            'summarize':'true'
            }
        try:
            data=''
            for key in params.keys():
                data=data+key+'='+params[key]+'&'

            req = urllib2.Request(SERVER_METRIC_URL.format(server_id)+'?'+data,headers=headers)
            response = urllib2.urlopen(req).read()
            return json.loads(response)
        except Exception as e:
            print e.message

        return []

    def run(self,server_id,metric_base_name,time_from,time_to,actual_metrics=None ):
        metricData=self.getServerDiskMetricData(server_id,metric_base_name,time_from,time_to,actual_metrics)
        ##print  json.dumps(metricData, sort_keys=True,indent=4, separators=(',', ': '))
        return  json.dumps(metricData, sort_keys=True,indent=4, separators=(',', ': '))


if __name__ == "__main__":
    ServerDiskUtilization().run('2105574','System/Swap/Used/bytes','2016-02-19T14:19:01+00:00','2016-02-19T14:49:01+00:00')