__author__ = 'adam'

from st2actions.runners.pythonrunner import Action

import json
import urllib2

__all__ =[
    'ServerMemoryUtilization'
]

SERVER_LIST_URL = 'https://api.newrelic.com/v2/servers.json'
SERVER_METRIC_URL = 'https://api.newrelic.com/v2/servers/{0}/metrics/data.json'
USER_NAME = '<user>'
PASSWORD = '<passwd'
SERVER_METRIC_NAME = 'System/Memory/Used/bytes'

class ServerMemoryUtilization(Action):

    def basic_authorization(self, user, password):
        s = user + ":" + password
        return "Basic " + s.encode("base64").rstrip()

    def getServerList(self):
        headers = {
            'X-Api-Key': self.config.get('api_key', None),
            'Content-Type': 'application/json'
        }

        req = urllib2.Request(SERVER_LIST_URL, headers=headers)
        response = urllib2.urlopen(req).read()
        servers = json.loads(response['server'])
        return servers

    def getServerMemoryData(self, server_id, metric_base_name, time_from, time_to, actual_metrics):
        headers = {
            'X-Api-Key': self.config.get('api_key', None),
        }
        params = {
            'names[]': metric_base_name,
            'from': time_from,
            'to': time_to,
            'summarize': 'true'
        }
        try:
            data = ''
            for key in params.keys():
                data = data+key+'='+params[key] + '&'

            req = urllib2.Request(SERVER_METRIC_URL.format(server_id) + '?' + data, headers=headers)
            response = urllib2.urlopen(req).read()
            return json.loads(response)
        except Exception as error:
            print error.message

        return []

    def run(self, server_id, metric_base_name, time_from, time_to, actual_metrics=None):
        metricData = self.getServerMemoryData(server_id, metric_base_name,time_from, time_to, actual_metrics)
        return json.dumps(metricData, sort_keys=True, indent=4, separators=(',', ': '))

if __name__ == "__main__":
    ServerMemoryUtilization().run('2105574', 'System/Memory/Used/bytes', '2016-02-19T14:19:01+00:00', '2016-02-19T14:49:01+00:00')