from st2actions.runners.pythonrunner import Action
import os
import sys

from st2common.constants import action as action_constants
import retrying
import requests
import json
import base64
import datetime
import time
from sonar_base import SonarBase



__all__ = [
    'SonarMetrics'
]

class SonarMetrics(SonarBase):

    def run(self, component_key, metricKey, subtractSeconds):
        if self.authenticate():
        	version_data = None

        	version_response=requests.post(self.config['server']+'/api/system/status')
        	try:
        	    version_data = json.loads(version_response.text)
		    print 'Sonarqube version '+version_data['version']  #Version >= 5.2, new metricsKey api supported
       		except ValueError:
       			print 'No version data available. Version < 5.2'  #Version < 5.2, old timemachine metrics api supported

       		if version_data == None:

			newtime = datetime.datetime.now() - datetime.timedelta(seconds=(subtractSeconds))
			print newtime.strftime('%Y-%m-%dT%H:%M:%S')
			if metricKey == None:
				params='resource='+component_key+'&metrics='+self.config['metricKeys']+'&fromDateTime='+newtime.strftime('%Y-%m-%dT%H%M%S')   #if metricKey none, use sonar_metrics kv 
			else:
				params='resource='+component_key+'&metrics='+metricKey+'&fromDateTime='+newtime.strftime('%Y-%m-%dT%H:%M:%S')  #if metricKey provided, use 
				
			response=requests.get(self.config['server']+'/api/timemachine?'+params)
			return response.json()
	        elif 'version' in version_data:
			if metricKey == None:
		    		params='componentKey='+component_key+'&metricKeys='+self.config['metricKeys']
			else:
				params='componentKey='+component_key+'&metricKeys='+metricKey
            		response=requests.post(self.config['server']+'/api/measures/component?'+params)
            		return response.json()
            
if __name__ == "__main__":
#    xd=SonarMetrics().run('org.sonarqube:java-simple-sq-scanner')
    xd=SonarMetrics().run('ik.am.jpetstore','2012-01-01T00:00:00+0100')
