'''
Created on Jun 2, 2016

@author: Sreedhar
'''


from st2reactor.sensor.base import PollingSensor

import sys
import requests
import base64
import datetime

class SonarQubeSensor(PollingSensor):
    def __init__(self, sensor_service, config=None, poll_interval=5):
        super(SonarQubeSensor, self).__init__(sensor_service=sensor_service, config=config, poll_interval=poll_interval)
        self.lastAnalysisTime=None
        self.debugMode=False

    def setup(self):
        pass

    def authenticate(self):
        headers={"Authorization": "BASIC " +  base64.b64encode(self._config['username'] + ":"+self._config['password'])}
        response=requests.post(self.sonar_config['server']+'/api/authentication/validate', headers=headers,verify=False)
        res=response.json()
        return res['valid']
    
    def poll(self):
        if self.authenticate():
            response=requests.post(self.sonar_config['server']+'/api/projects/')
            projects= response.json()

            for project in projects:
                component_key=project['k']
                params='componentKey='+component_key+'&metricKeys='+self.sonar_config['metricKeys']
                res=requests.post(self.sonar_config['server']+'/api/measures/component?'+params)
                metrics=res.json()
                payload = {"body":metrics}
                self._sensor_service.dispatch(trigger="sonarqube.new_analysis",payload=payload)
        print 'dispatched to trigger sonarqube.new_analysis'


    def cleanup(self):
        pass

    def add_trigger(self, trigger):
        pass

    def update_trigger(self, trigger):
        pass

    def remove_trigger(self, trigger):
        pass

if __name__ == "__main__":
    obj=SonarQubeSensor()
    obj.config={}
    obj.sonar_config={'username': 'admin',
                        'server': 'http://localhost:9000',
                        'metricKeys': 'ncloc,complexity,violations'
                      }
    obj.lastAnalysisTime=None
    obj.debugMode=True
    obj.poll()
    obj.poll()
    obj.poll()
