'''
Created on Mar 10, 2016

@author: Sreedhar
'''

import json
from st2actions.runners.pythonrunner import Action

__all__ = [
    'CreateTFSCommitEventJSON'
]


class CreateTFSCommitEventJSON(Action):
    def run(self,  apiversion,sourceassockey,repo_id,branch_name,event_time,tfs_commit_info):
        if tfs_commit_info == None:
          print 'Commit Info is required'
          return

        created_by=''
        for ps in tfs_commit_info['checkin']['ChangesetOwner']['PropertiesSet']:
            if ps['PropertyName'] == 'Account':
                created_by=ps['Value']
                break

        path=[]
        if tfs_commit_info['checkin']['SubmittedItems'] != None:
            for item in tfs_commit_info['checkin']['SubmittedItems']:
                d={}
                d['action']='modified'
                d['path']=item
                path.append(d)

        obj = {"api_version": str(apiversion), "source_association_key": str(sourceassockey),
               "commit_data": {"repo_id": str(repo_id),
                               "revision_id": str(tfs_commit_info['checkin']['Changeset']), "branch_name": str(branch_name),
                               "type": tfs_commit_info['checkin']['CheckinType'], "message": str(tfs_commit_info['checkin']['Comment']), "path": path,
                               "event_time": str(event_time), "created_by": str(created_by)}}
        print json.dumps(obj,False)
        return json.dumps(obj,False)

if __name__ == "__main__":
    commit_info= {	"checkin": {
		"Changeset": 62,
		"Comment": "",
		"ComputerName": "MSCHWARTZ-W550S",
		"NotificationInfo": {
			"WorkItemInfo": []
		},
		"Options": 1,
		"CheckinNote": {
			"Values": None
		},
		"PolicyOverrideInfo": {
			"Comment": None,
			"PolicyFailures": None
		},
		"ChangesetOwner": {
			"Descriptor": "System.Security.Principal.WindowsIdentity;S-1-5-21-2379620384-1736772847-2924272803-12699",
			"DisplayName": "Michael Schwartz",
			"AttributesSet": None,
			"PropertiesSet": [{
				"PropertyName": "SchemaClassName",
				"Value": "User",
				"ChangedBy": None,
				"ChangedDate": None,
				"TypeMatch": 0
			},
			{
				"PropertyName": "Description",
				"Value": "",
				"ChangedBy": None,
				"ChangedDate": None,
				"TypeMatch": 0
			},
			{
				"PropertyName": "Domain",
				"Value": "SP",
				"ChangedBy": None,
				"ChangedDate": None,
				"TypeMatch": 0
			},
			{
				"PropertyName": "Account",
				"Value": "mschwartz",
				"ChangedBy": None,
				"ChangedDate": None,
				"TypeMatch": 0
			},
			{
				"PropertyName": "DN",
				"Value": "CN=Michael Schwartz,OU=Remote,OU=People,DC=sp,DC=corp,DC=collab,DC=net",
				"ChangedBy": None,
				"ChangedDate": None,
				"TypeMatch": 0
			},
			{
				"PropertyName": "Mail",
				"Value": "",
				"ChangedBy": None,
				"ChangedDate": None,
				"TypeMatch": 0
			},
			{
				"PropertyName": "SpecialType",
				"Value": "Generic",
				"ChangedBy": None,
				"ChangedDate": None,
				"TypeMatch": 0
			}],
			"LocalPropertiesSet": [],
			"IsContainer": False,
			"IsActive": True,
			"TeamFoundationId": "60a59011-0fed-4b48-ac0a-cfa6ae7159f9",
			"UniqueName": "SP\\mschwartz",
			"UniqueUserId": 0,
			"Members": [],
			"MemberOf": [],
			"MembersSet": None,
			"MemberOfSet": None
		},
		"ChangesetOwnerName": "SP\\mschwartz",
		"WorkspaceOwner": {
			"Descriptor": "System.Security.Principal.WindowsIdentity;S-1-5-21-2379620384-1736772847-2924272803-12699",
			"DisplayName": "Michael Schwartz",
			"AttributesSet": None,
			"PropertiesSet": [{
				"PropertyName": "SchemaClassName",
				"Value": "User",
				"ChangedBy": None,
				"ChangedDate": None,
				"TypeMatch": 0
			},
			{
				"PropertyName": "Description",
				"Value": "",
				"ChangedBy": None,
				"ChangedDate": None,
				"TypeMatch": 0
			},
			{
				"PropertyName": "Domain",
				"Value": "SP",
				"ChangedBy": None,
				"ChangedDate": None,
				"TypeMatch": 0
			},
			{
				"PropertyName": "Account",
				"Value": "mschwartz",
				"ChangedBy": None,
				"ChangedDate": None,
				"TypeMatch": 0
			},
			{
				"PropertyName": "DN",
				"Value": "CN=Michael Schwartz,OU=Remote,OU=People,DC=sp,DC=corp,DC=collab,DC=net",
				"ChangedBy": None,
				"ChangedDate": None,
				"TypeMatch": 0
			},
			{
				"PropertyName": "Mail",
				"Value": "",
				"ChangedBy": None,
				"ChangedDate": None,
				"TypeMatch": 0
			},
			{
				"PropertyName": "SpecialType",
				"Value": "Generic",
				"ChangedBy": None,
				"ChangedDate": None,
				"TypeMatch": 0
			}],
			"LocalPropertiesSet": [],
			"IsContainer": False,
			"IsActive": True,
			"TeamFoundationId": "60a59011-0fed-4b48-ac0a-cfa6ae7159f9",
			"UniqueName": "SP\\mschwartz",
			"UniqueUserId": 0,
			"Members": [],
			"MemberOf": [],
			"MembersSet": None,
			"MemberOfSet": None
		},
		"WorkspaceOwnerName": "SP\\mschwartz",
		"WorkspaceName": "MSCHWARTZ-W550S",
		"CheckinType": 0,
		"SubmittedItems": ["$/Test/Test/test.txt"],
		"HasAllItems": True
	},
	"submittedItems": None
	}

    CreateTFSCommitEventJSON().run("1","150e8951-19e1-4066-8b74-601026dd6cde","390e8951-19e1-4066-8b74-601026dd6cde","master","2012-10-02T17:15:32.320Z",commit_info)