from st2actions.runners.pythonrunner import Action
import base64
import requests
from requests_ntlm import HttpNtlmAuth

__all__ = [
    'TFSGetLastCommit'
]

TFS_URL='{0}/tfs/{1}/_apis/tfvc/changesets?api-version=1.0&searchCriteria.itemPath={2}&$top=1'
class TFSGetLastCommit(Action):
    def basic_authorization(self, user, password):
        return 'BASIC {}'.format(base64.b64encode('{}:{}'.format(user, password)))
    def run(self, collection, repo):
        try:
            response=requests.get(TFS_URL.format(self.config['url'], collection, repo),auth=HttpNtlmAuth(self.config['username'], self.config['password']))


            print response.json()
            return response.json()
        except Exception as e:
            print e
