'''
Created on Mar 15, 2016

@author: Sreedhar
'''


from st2reactor.sensor.base import PollingSensor
from st2client.client import Client
from st2client.models.keyvalue import KeyValuePair
import sys
import requests
import base64
import datetime

class UBuildActivitySensor(PollingSensor):
    def __init__(self, sensor_service, config=None, poll_interval=5):
        super(UBuildActivitySensor, self).__init__(sensor_service=sensor_service, config=config, poll_interval=poll_interval)
        self._client = Client(base_url='http://localhost')

    def setup(self):
        pass

    def poll(self):
        encoded_creds = base64.b64encode('{}:{}'.format(self._config['user'],self._config['password']))
        headers={'Authorization': 'BASIC {}'.format(encoded_creds)}
        projects=self._config['projects'].split(',')
        for project in projects:
        	try:
	            ucount_key=project+'-ubuild-count'
	            proj_proc=project.split('-')
	            response=requests.get(self._config['url'].format(proj_proc[0],proj_proc[1]), headers=headers,verify=False)
	            activities= response.json()
	            new_activities=[]
	            lastBuildLifeKey=self._client.keys.get_by_name(ucount_key)
	            lastBuildLifeId=0
	            if  lastBuildLifeKey!= None:
	                lastBuildLifeId=int(lastBuildLifeKey.value)
	                for activity in activities:
	                    if activity['buildLifeId'] > lastBuildLifeId:
	                        new_activities.append(activity)
	            else:
	                new_activities=activities
	
	            if len(new_activities) > 0:
	                for activity in new_activities:
	                    if activity['buildLifeId'] > lastBuildLifeId:
	                        lastBuildLifeId=activity['buildLifeId']
	                    start=activity['startDate'].split()
	                    start[4]=''
	                    end=activity['endDate'].split()
	                    end[4]=''
	                    activity['duration']=(datetime.datetime.strptime(' '.join(end),'%a %b %d %H:%M:%S  %Y')-datetime.datetime.strptime(' '.join(start),'%a %b %d %H:%M:%S  %Y')).seconds
	                    #print activity
	                    payload = {"body":activity}
	                    self._sensor_service.dispatch(trigger="ubuild.new_build_activity",payload=payload)
	
	            if lastBuildLifeKey == None:
	                lastBuildLifeKey=KeyValuePair()
	            lastBuildLifeKey.id = ucount_key
	            lastBuildLifeKey.name = ucount_key
	            lastBuildLifeKey.value = str(lastBuildLifeId)
	            self._client.keys.update(lastBuildLifeKey)
	            print 'dispatched to trigger ubuild.new_build_activity'
    		except:
    			print("Unexpected error:", sys.exc_info()[0])


    def cleanup(self):
        pass

    def add_trigger(self, trigger):
        pass

    def update_trigger(self, trigger):
        pass

    def remove_trigger(self, trigger):
        pass

if __name__ == "__main__":
    obj=UBuildActivitySensor()
    obj.lastBuildLifeIds={}
    obj.poll()
    obj.poll()
    obj.poll()