from st2actions.runners.pythonrunner import Action
from st2client.client import Client
import cx_Oracle
__all__ = [
    'check_request_status'
]

class check_request_status(Action):
    def run(self, request):
        try:
            self._st2_client = Client(base_url='http://localhost')
            oracle_host = self.config.get('oracle_host')
            # @TODO: make sure this works with string vs int
            oracle_port = self.config.get('oracle_port') or 1521
            oracle_sid = self.config.get('oracle_sid')
            dsn_tns = cx_Oracle.makedsn(oracle_host, oracle_port, oracle_sid)
            username = self.config.get('oracle_username')
            password = self.config.get('oracle_password')
            db = cx_Oracle.connect(username, password, dsn_tns)
            self._cursor = db.cursor()

            query = ('SELECT RT_APP_PROCESS_REQUEST.RESULT AS STATUS, RT_APP_PROCESS_REQUEST.SUBMITTED_TIME AS SUBMITTED_TIME, RT_APP_PROCESS_REQUEST.ID AS REQUEST, DS_ENVIRONMENT.NAME AS ENVIRONMENT, DS_VERSION.NAME AS VERSION, DS_COMPONENT.NAME AS COMPONENT, SEC_USER.NAME AS USERID, WF_WORKFLOW_METADATA.DURATION_TIME AS DURATION, DS_APPLICATION.NAME AS APP ' +
                 'from RT_APP_PROCESS_REQUEST ' +
                 ' INNER JOIN RT_APP_PROC_REQ_TO_VERSION ON RT_APP_PROCESS_REQUEST.ID = RT_APP_PROC_REQ_TO_VERSION.APP_PROCESS_REQUEST_ID INNER JOIN DS_VERSION ON RT_APP_PROC_REQ_TO_VERSION.VERSION_ID = DS_VERSION.ID INNER JOIN DS_COMPONENT ON DS_VERSION.COMPONENT_ID = DS_COMPONENT.ID INNER JOIN SEC_USER ON RT_APP_PROCESS_REQUEST.USER_ID = SEC_USER.ID INNER JOIN DS_ENVIRONMENT ON RT_APP_PROCESS_REQUEST.ENVIRONMENT_ID=DS_ENVIRONMENT.ID INNER JOIN WF_WORKFLOW_METADATA  ON RT_APP_PROCESS_REQUEST.TRACE_ID = WF_WORKFLOW_METADATA.WORKFLOW_TRACE_ID INNER JOIN DS_APPLICATION ON RT_APP_PROCESS_REQUEST.APPLICATION_ID = DS_APPLICATION.ID ' +
                 'where RT_APP_PROCESS_REQUEST.ID in (\'{}\')').format(request)
            self._cursor.execute(query)
            results = self._cursor.fetchall()
            if results:
                for result in results:
                    status, latest_time, _, _, _, _, _, _, _ = result
                    if status is not None:
                        STATUS, SUBMITTED_TIME, REQUEST, ENVIRONMENT, VERSION, COMPONENT, USERID, DURATION, APP = result
                        return {'status': STATUS, 'submitted_time': SUBMITTED_TIME, 'request': REQUEST, 'environment': ENVIRONMENT, 'version': VERSION, 'component': COMPONENT, 'userid': USERID, 'duration': DURATION, 'app': APP}
                    else:
			return (None);
        except Exception as e:
            print e
