'''
Created on Sept 6, 2016

@author: Sreedhar
'''


from st2reactor.sensor.base import PollingSensor
from st2client.client import Client
from st2client.models.keyvalue import KeyValuePair
import sys
import requests
import base64
import datetime

class UdeploySensor(PollingSensor):
    def __init__(self, sensor_service, config=None, poll_interval=5):
        super(UdeploySensor, self).__init__(sensor_service=sensor_service, config=config, poll_interval=poll_interval)
        self._client = Client(base_url='http://localhost')

    def setup(self):
        pass

    def poll(self):
        encoded_creds = base64.b64encode('{}:{}'.format(self._config['user'],self._config['password']))
        headers={'Authorization': 'BASIC {}'.format(encoded_creds)}
        app_ids=self._config['application_ids'].split(',')
        for app_id in app_ids:
            utime_key=app_id+'-udeploy-time'
            response=requests.get((self._config['url']+'/rest/deploy/applicationProcessRequest/table?filterValue_application.id={0}').format(app_ids), headers=headers,verify=False)
            deployments= response.json()
            new_deployments=[]
            lastDeploymentTimeKey=self._client.keys.get_by_name(utime_key)
            lastDeploymentTime=0
            if  lastDeploymentTimeKey!= None:
                lastDeploymentTime=int(lastDeploymentTimeKey.value)
                for deployment in deployments:
                    if deployment['submittedTime'] > lastDeploymentTime:
                        new_deployments.append(deployment)
            else:
                new_deployments=deployments

            if len(new_deployments) > 0:
                for deployment in new_deployments:
                    if deployment['submittedTime'] > lastDeploymentTime:
                        lastDeploymentTime=deployment['submittedTime']
                    payload = {"body":deployment}
                    self._sensor_service.dispatch(trigger="udeploy.new_deployment",payload=payload)

            if lastDeploymentTimeKey == None:
                lastDeploymentTimeKey=KeyValuePair()
            lastDeploymentTimeKey.id = utime_key
            lastDeploymentTimeKey.name = utime_key
            lastDeploymentTimeKey.value = str(lastDeploymentTime)
            self._client.keys.update(lastDeploymentTimeKey)
            print 'dispatched to trigger udeploy.new_deployment'


    def cleanup(self):
        pass

    def add_trigger(self, trigger):
        pass

    def update_trigger(self, trigger):
        pass

    def remove_trigger(self, trigger):
        pass

if __name__ == "__main__":
    obj=UdeploySensor()
    obj.poll()
    obj.poll()
    obj.poll()