__author__ = "Preston Belmar"

import urllib2
import xml.etree.ElementTree
import zapv2
from st2actions.runners.pythonrunner import Action


### Config directory
config = '/opt/stackstorm/packs/zap/config/version.xml'


class update(Action):

    def run(self):
        self.get_current()
        self.check_version()

    def get_current(self):
        f = open(config, 'w+')
        f.write(urllib2.urlopen('https://raw.githubusercontent.com/zaproxy/zap-admin/master/ZapVersions.xml').read())
        f.close()

    def check_version(self):
        zap = zapv2.ZAPv2()
        update = zapv2.autoupdate(zap)
        try:
            if type(update.latest_version_number) != unicode:
                print 'Version not found'
                return 1
            else:
                current = update.latest_version_number
                root = xml.etree.ElementTree.parse(config).getroot()
                version = root.findall('./core/version')[0].text
                if version == current:
                    print "Version is current"
                    return 0
                else:
                    print "Version out of date"
                    return 0
        except IOError:
            print "Daemon not running"
            return 1

if __name__ == '__main__':
    update(Action)